$(() => {
const gauge = $('#gauge').dxLinearGauge({
scale: {
startValue: 0,
endValue: 10,
tickInterval: 2,
label: {
customizeText(arg) {
return `${arg.valueText} kW`;
},
},
},
tooltip: {
enabled: true,
customizeTooltip(arg) {
let result = `${arg.valueText} kW`;
if (arg.index >= 0) {
result = `Secondary ${arg.index + 1}: ${result}`;
} else {
result = `Primary: ${result}`;
}
return {
text: result,
};
},
},
export: {
enabled: true,
},
title: {
text: 'Power of Air Conditioners in Store Departments (kW)',
font: { size: 28 },
},
value: dataSource[0].primary,
subvalues: dataSource[0].secondary,
}).dxLinearGauge('instance');
$('#selectbox').dxSelectBox({
dataSource,
displayExpr: 'name',
onValueChanged(data) {
gauge.value(data.value.primary);
gauge.subvalues(data.value.secondary);
},
value: dataSource[0],
width: 200,
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.3/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/22.2.3/js/dx.all.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="gauge-demo">
<div id="gauge"></div>
<div id="selectbox"></div>
</div>
</div>
</body>
</html>
#gauge-demo {
height: 440px;
width: 100%;
}
#gauge {
height: 400px;
}
const dataSource = [{
name: 'Meat',
primary: 8,
secondary: [7, 3],
}, {
name: 'Fish',
primary: 7,
secondary: [7, 5, 1],
}, {
name: 'Grocery',
primary: 5,
secondary: [1, 3],
}, {
name: 'Greengrocery',
primary: 3,
secondary: [1],
}, {
name: 'Stationery',
primary: 2,
secondary: [],
}];

import React from 'react';
import {
LinearGauge, Scale, Label, Tooltip, Export, Title, Font,
} from 'devextreme-react/linear-gauge';
import { SelectBox } from 'devextreme-react/select-box';
import { dataSource } from './data.js';
class App extends React.Component {
constructor(props) {
super(props);
this.state = {
value: dataSource[0].primary,
subvalues: dataSource[0].secondary,
};
this.onValueChanged = ({ value }) => {
this.setState({
value: value.primary,
subvalues: value.secondary,
});
};
}
render() {
return (
<div id="gauge-demo">
<LinearGauge
id="gauge"
value={this.state.value}
subvalues={this.state.subvalues}
>
<Scale startValue={0} endValue={10} tickInterval={2}>
<Label customizeText={this.customizeText} />
</Scale>
<Tooltip enabled={true} customizeTooltip={this.customizeTooltip} />
<Export enabled={true} />
<Title text="Power of Air Conditioners in Store Departments (kW)">
<Font size={28} />
</Title>
</LinearGauge>
<SelectBox
id="selectbox"
dataSource={dataSource}
defaultValue={dataSource[0]}
width={200}
displayExpr="name"
onValueChanged={this.onValueChanged}
/>
</div>
);
}
customizeText({ valueText }) {
return `${valueText} kW`;
}
customizeTooltip(arg) {
let result = `${arg.valueText} kW`;
if (arg.index >= 0) {
result = `Secondary ${(arg.index + 1)}: ${result}`;
} else {
result = `Primary: ${result}`;
}
return {
text: result,
};
}
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="dx-theme" data-theme="generic.light" href="https://cdn3.devexpress.com/jslib/22.2.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#gauge-demo {
height: 440px;
width: 100%;
}
#gauge {
height: 400px;
}
export const dataSource = [{
name: 'Meat',
primary: 8,
secondary: [7, 3],
}, {
name: 'Fish',
primary: 7,
secondary: [7, 5, 1],
}, {
name: 'Grocery',
primary: 5,
secondary: [1, 3],
}, {
name: 'Greengrocery',
primary: 3,
secondary: [1],
}, {
name: 'Stationery',
primary: 2,
secondary: [],
}];
window.config = {
transpiler: 'plugin-babel',
meta: {
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
defaultExtension: 'js',
map: {
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.8.1/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.2.3/cjs',
'devextreme-react': 'npm:devextreme-react@22.2.3',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.20/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.65/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.37/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.7.1/standalone.js',
'prettier/parser-html': 'npm:prettier@2.7.1/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);

<template>
<div>
<div id="gauge-demo">
<dx-linear-gauge
id="gauge"
:value="value.primary"
:subvalues="value.secondary"
>
<dx-scale
:start-value="0"
:end-value="10"
:tick-interval="2"
>
<dx-label
:customize-text="customizeText"
/>
</dx-scale>
<dx-tooltip
:enabled="true"
:customize-tooltip="customizeTooltip"
/>
<dx-export
:enabled="true"
/>
<dx-title
text="Power of Air Conditioners in Store Departments (kW)"
>
<dx-font
:size="28"
/>
</dx-title>
</dx-linear-gauge>
<dx-select-box
id="selectbox"
:data-source="dataSource"
:value.sync="value"
:width="200"
display-expr="name"
/>
</div>
</div>
</template>
<script>
import { dataSource } from './data.js';
import { DxLinearGauge, DxScale, DxLabel, DxTooltip, DxExport, DxTitle, DxFont } from 'devextreme-vue/linear-gauge';
import { DxSelectBox } from 'devextreme-vue/select-box';
export default {
components: {
DxLinearGauge, DxScale, DxLabel, DxTooltip, DxExport, DxTitle, DxFont,
DxSelectBox
},
data() {
return {
dataSource: dataSource,
value: dataSource[0]
};
},
methods: {
customizeText({ valueText }) {
return `${valueText} kW`;
},
customizeTooltip(scaleValue) {
var result = `${scaleValue.valueText} kW`;
if (scaleValue.index >= 0) {
result = `Secondary ${scaleValue.index + 1}: ${result}`;
} else {
result = `Primary: ${result}`;
}
return {
text: result
};
}
}
};
</script>
<style scoped>
#gauge-demo {
height: 440px;
width: 100%;
}
#gauge {
height: 400px;
}
</style>
import Vue from 'vue';
import App from './App.vue';
new Vue({
el: '#app',
components: { App },
template: '<App/>'
});
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/19.2.4/css/dx.common.css" />
<link rel="dx-theme" data-theme="generic.light" href="https://cdn3.devexpress.com/jslib/19.2.4/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import('./index.js');
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app">
</div>
</div>
</body>
</html>
export const dataSource = [{
name: 'Meat',
primary: 8,
secondary: [7, 3]
}, {
name: 'Fish',
primary: 7,
secondary: [7, 5, 1]
}, {
name: 'Grocery',
primary: 5,
secondary: [1, 3]
}, {
name: 'Greengrocery',
primary: 3,
secondary: [1]
}, {
name: 'Stationery',
primary: 2,
secondary: []
}];
System.config({
transpiler: 'plugin-babel',
paths: {
'npm:': 'https://unpkg.com/'
},
map: {
vue: 'npm:vue@2.5.16/dist/vue.esm.browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@latest/index.js',
'devextreme': 'npm:devextreme@19.2',
'devextreme-vue': 'npm:devextreme-vue@19.2',
jszip: 'npm:jszip@3.1.3/dist/jszip.min.js',
'quill': 'npm:quill@1.3.7/dist/quill.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0/plugin-babel.js',
'systemjs-babel-build':
'npm:systemjs-plugin-babel@0/systemjs-babel-browser.js'
},
meta: {
'*.vue': { loader: 'vue-loader' }
},
packages: {
'devextreme-vue': {
main: 'index.js'
},
'devextreme': {
defaultExtension: 'js'
}
},
babelOptions: {
sourceMaps: false,
stage0: true
}
});

DevExtreme v23.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Variable Number of Subvalue Indicators

Documentation

This demo shows how to use the API of the LinearGauge to change its value and subvalue indicators at runtime. To get and set values of the indicators, the value and subvalues methods are utilized.

Backend API
<div id="gauge-demo"> <dx-linear-gauge id="gauge" [value]="currentValue.primary" [subvalues]="currentValue.secondary" > <dxo-scale [startValue]="0" [endValue]="10" [tickInterval]="2"> <dxo-label [customizeText]="customizeText"></dxo-label> </dxo-scale> <dxo-tooltip [enabled]="true" [customizeTooltip]="customizeTooltip" ></dxo-tooltip> <dxo-export [enabled]="true"></dxo-export> <dxo-title text="Power of Air Conditioners in Store Departments (kW)"> <dxo-font [size]="28"></dxo-font> </dxo-title> </dx-linear-gauge> <dx-select-box #select [dataSource]="powerInfo" [inputAttr]="{ 'aria-label': 'Department' }" displayExpr="name" [(value)]="currentValue" [width]="200" > </dx-select-box> </div>
import { NgModule, Component, enableProdMode } from '@angular/core'; import { BrowserModule, BrowserTransferStateModule } from '@angular/platform-browser'; import { platformBrowserDynamic } from '@angular/platform-browser-dynamic'; import { DxSelectBoxModule } from 'devextreme-angular'; import { DxLinearGaugeModule, DxLinearGaugeTypes } from 'devextreme-angular/ui/linear-gauge'; import { Service, PowerInfo } from './app.service'; if (!/localhost/.test(document.location.host)) { enableProdMode(); } @Component({ selector: 'demo-app', templateUrl: 'app/app.component.html', styleUrls: ['app/app.component.css'], providers: [Service], }) export class AppComponent { powerInfo: PowerInfo[]; currentValue: PowerInfo; constructor(service: Service) { this.powerInfo = service.getPowerInfo(); this.currentValue = this.powerInfo[0]; } customizeText: DxLinearGaugeTypes.ScaleLabel['customizeText'] = ({ valueText }) => `${valueText} kW`; customizeTooltip({ index, valueText }) { let result = `${valueText} kW`; result = (index >= 0) ? `Secondary ${index + 1}: ${result}` : `Primary: ${result}`; return { text: result, }; } } @NgModule({ imports: [ BrowserModule, BrowserTransferStateModule, DxLinearGaugeModule, DxSelectBoxModule, ], declarations: [AppComponent], bootstrap: [AppComponent], }) export class AppModule { } platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep #gauge-demo { height: 440px; width: 100%; } ::ng-deep #gauge { height: 400px; }
import { Injectable } from '@angular/core'; export class PowerInfo { name: string; primary: number; secondary: number[]; } const powerInfo: PowerInfo[] = [{ name: 'Meat', primary: 8, secondary: [7, 3], }, { name: 'Fish', primary: 7, secondary: [7, 5, 1], }, { name: 'Grocery', primary: 5, secondary: [1, 3], }, { name: 'Greengrocery', primary: 3, secondary: [1], }, { name: 'Stationery', primary: 2, secondary: [], }]; @Injectable() export class Service { getPowerInfo(): PowerInfo[] { return powerInfo; } }
// In real applications, you should not transpile code in the browser. // You can see how to create your own application with Angular and DevExtreme here: // https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/ window.exports = window.exports || {}; window.config = { transpiler: 'ts', typescriptOptions: { module: 'system', emitDecoratorMetadata: true, experimentalDecorators: true, }, meta: { 'typescript': { 'exports': 'ts', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, }, paths: { 'npm:': 'https://unpkg.com/', }, map: { 'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', '@angular/core': 'npm:@angular/core@12.2.17', '@angular/platform-browser': 'npm:@angular/platform-browser@12.2.17', '@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@12.2.17', '@angular/forms': 'npm:@angular/forms@12.2.17', '@angular/common': 'npm:@angular/common@12.2.17', '@angular/compiler': 'npm:@angular/compiler@12.2.17', 'tslib': 'npm:tslib@2.6.2/tslib.js', 'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js', 'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign@1.1.0', 'devextreme': 'npm:devextreme@23.2.5/cjs', 'devextreme/bundles/dx.all': 'npm:devextreme@23.2.5/bundles/dx.all.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'devextreme-quill': 'npm:devextreme-quill@1.6.4/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.5', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.51', 'devextreme-angular': 'npm:devextreme-angular@23.2.5', '@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12', 'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.4/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js', }, packages: { 'app': { main: './app.component.ts', defaultExtension: 'ts', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, 'rxjs': { defaultExtension: 'js', }, 'rxjs/operators': { defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', 'npm:@devextreme/runtime@3.0.12/inferno/package.json', 'npm:@angular/*/package.json', 'npm:@angular/common@12.2.17/*/package.json', 'npm:rxjs@7.5.3/package.json', 'npm:rxjs@7.5.3/operators/package.json', 'npm:devextreme-angular@23.2.5/*/package.json', 'npm:devextreme-angular@23.2.5/ui/*/package.json', 'npm:devextreme-angular@23.2.5/package.json', 'npm:devexpress-diagram@2.2.5/package.json', 'npm:devexpress-gantt@4.1.51/package.json', ], }; System.config(window.config);
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.2.5/css/dx.light.css" /> <script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script> <script src="https://unpkg.com/zone.js@0.12.0/dist/zone.js"></script> <script src="https://unpkg.com/reflect-metadata@0.1.13/Reflect.js"></script> <script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script> <script src="config.js"></script> <script> System.import("app").catch(console.error.bind(console)); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <demo-app>Loading...</demo-app> </div> </body> </html>